from behave import fixture, use_fixture

from tui_rsync.core.components.backup_plan.application.repository.backup_plan_repository import BackupPlanRepository
from tui_rsync.infrastructure.orm import InMemoryDatabaseManager


@fixture
def setup_in_memory_database_manager(context):
    context.db = InMemoryDatabaseManager()
    yield context.db


@fixture
def setup_backup_plan_repository(context):
    context.backup_plan_repository = BackupPlanRepository(context.db)
    yield context.db


def before_tag(context, tag):
    if tag == "fixture.in_memory_database":
        use_fixture(setup_in_memory_database_manager, context)
    if tag == "fixture.backup_plan_repository":
        use_fixture(setup_backup_plan_repository, context)
